/* InitBinLayoutLinear.hpp 
 * 
 * Copyright (C) 2010 Sylwester Arabas
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

#ifndef INIT_BIN_LAYOUT_LINEAR_HPP
#  define INIT_BIN_LAYOUT_LINEAR_HPP

#  define self InitBinLayoutLinear
class self : public InitBinLayout
{

  private: quantity<si::length> leftEnd, rightEnd, binWidth;
  private: size_t n_bins;

  public: self(size_t n_bins_, quantity<si::length> leftEnd_, quantity<si::length> rightEnd_)
  {
    n_bins = n_bins_;
    leftEnd = leftEnd_;
    rightEnd = rightEnd_;
    binWidth = (rightEnd - leftEnd) / realtype(n_bins);
  }

  public: quantity<si::length> getLeftEdge(size_t n)
  {
    assert(n >=0 && n < n_bins);
    return leftEnd + realtype(n) * binWidth;
  }

  public: quantity<si::length> getRightEdge(size_t n)
  {
    assert(n >=0 && n < n_bins);
    return rightEnd - realtype(n_bins - n - 1) * binWidth;
  }

  public: bool binNeedsMerging(quantity<si::length>, quantity<si::length>, 
    quantity<si::length>, quantity<si::length>, quantity<specific_concentration> specConc)
  {
    // TODO! move from here
    assert(false);
  }

  public: size_t splitInto(quantity<specific_concentration>)
  {
    // TODO! move from here
    assert(false);
  }

};
#  undef self

#endif
